import { DecodedValueMap, QueryParamConfig, QueryParamConfigMap } from 'serialize-query-params';
export type URLUpdateType = 'push' | 'pushIn' | 'replace' | 'replaceIn';
type NewValueType<D> = D | ((latestValue: D) => D);
export type SetQueryLocal<QPCMap extends QueryParamConfigMap> = (changes: Partial<DecodedValueMap<QPCMap>> | ((latestValues: DecodedValueMap<QPCMap>) => Partial<DecodedValueMap<QPCMap>>), updateType?: URLUpdateType | undefined) => void;
/**
 * Given a query parameter configuration (mapping query param name to { encode, decode }),
 * return an object with the decoded values and a setter for updating them.
 */
export declare const useQueryParams: <QPCMap extends QueryParamConfigMap>(paramConfigMap: QPCMap) => [DecodedValueMap<QPCMap>, SetQueryLocal<QPCMap>];
export declare type SetValue<D> = (newValue: NewValueType<D>, updateType?: URLUpdateType | undefined) => void;
/**
 * Helper to get the latest decoded value with smart caching.
 * Abstracted into its own function to allow re-use in a functional setter (#26)
 */
export declare const useQueryParam: <D, D2 = D>(name: string, paramConfig?: QueryParamConfig<D, D2>) => [D2, SetValue<D>];
export {};
